Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1352)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute
 ! 
 ! Former revisions:
@@ -238,5 +238,5 @@
     
     REAL(wp)    ::  gradient                         !: 
-    REAL(wp)    ::  remote = 0.0                     !: 
+    REAL(wp)    ::  remote = 0.0_wp                  !: 
     REAL(wp)    ::  simulation_time_since_reference  !: 
 
@@ -307,5 +307,5 @@
           CALL message( 'check_parameters', 'PA0004', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( dt_coupling <= 0.0 )  THEN
+       IF ( dt_coupling <= 0.0_wp )  THEN
 #if ! defined( __check )
           IF ( myid == 0  ) THEN
@@ -505,5 +505,5 @@
 !
 !-- Check if vertical grid stretching is used together with particles
-    IF ( dz_stretch_level < 100000.0 .AND. particle_advection )  THEN
+    IF ( dz_stretch_level < 100000.0_wp .AND. particle_advection )  THEN
        message_string = 'Vertical grid stretching is not allowed together ' // &
                         'with particle advection.'
@@ -677,5 +677,5 @@
        CALL message( 'check_parameters', 'PA0024', 1, 2, 0, 6, 0 )
     ENDIF
-    IF ( scalar_advec == 'bc-scheme'  .AND.  loop_optimization == 'cache' ) &
+    IF ( scalar_advec == 'bc-scheme'  .AND.  loop_optimization == 'cache' )    &
     THEN
        message_string = 'advection_scheme scalar_advec = "' &
@@ -685,9 +685,9 @@
     ENDIF
 
-    IF ( use_sgs_for_particles  .AND.  .NOT. use_upstream_for_tke .AND.       &
+    IF ( use_sgs_for_particles  .AND.  .NOT. use_upstream_for_tke .AND.        &
          scalar_advec /= 'ws-scheme' )  THEN
        use_upstream_for_tke = .TRUE.
-       message_string = 'use_upstream_for_tke set .TRUE. because ' // &
-                        'use_sgs_for_particles = .TRUE. '          // &
+       message_string = 'use_upstream_for_tke set .TRUE. because ' //          &
+                        'use_sgs_for_particles = .TRUE. '          //          &
                         'and scalar_advec /= ws-scheme'
        CALL message( 'check_parameters', 'PA0025', 0, 1, 0, 6, 0 )
@@ -695,5 +695,5 @@
 
     IF ( use_sgs_for_particles  .AND.  curvature_solution_effects )  THEN
-       message_string = 'use_sgs_for_particles = .TRUE. not allowed with ' // &
+       message_string = 'use_sgs_for_particles = .TRUE. not allowed with ' //  &
                         'curvature_solution_effects = .TRUE.'
        CALL message( 'check_parameters', 'PA0349', 1, 2, 0, 6, 0 )
@@ -719,5 +719,5 @@
 
        CASE DEFAULT
-          message_string = 'unknown timestep scheme: timestep_scheme = "' // &
+          message_string = 'unknown timestep scheme: timestep_scheme = "' //   &
                            TRIM( timestep_scheme ) // '"'
           CALL message( 'check_parameters', 'PA0027', 1, 2, 0, 6, 0 )
@@ -725,5 +725,5 @@
     END SELECT
 
-    IF ( (momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme') &
+    IF ( (momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme')   &
          .AND. timestep_scheme(1:5) == 'runge' ) THEN
        message_string = 'momentum advection scheme "' // &
@@ -833,5 +833,5 @@
     ENDIF
 
-    IF ( plant_canopy .AND. ( drag_coefficient == 0.0 ) ) THEN
+    IF ( plant_canopy .AND. ( drag_coefficient == 0.0_wp ) ) THEN
        message_string = 'plant_canopy = .TRUE. requires a non-zero drag ' // &
                         'coefficient & given value is drag_coefficient = 0.0'
@@ -872,5 +872,5 @@
        IF ( ocean )           sa_init = sa_surface
        IF ( passive_scalar )  q_init  = s_surface
-       IF ( plant_canopy )    lad = 0.0
+       IF ( plant_canopy )    lad = 0.0_wp
 
 !
@@ -879,5 +879,5 @@
 !--    (component ug)
        i = 1
-       gradient = 0.0
+       gradient = 0.0_wp
 
        IF ( .NOT. ocean )  THEN
@@ -888,11 +888,11 @@
              IF ( i < 11 ) THEN
                 IF ( ug_vertical_gradient_level(i) < zu(k)  .AND. &
-                     ug_vertical_gradient_level(i) >= 0.0 )  THEN
-                   gradient = ug_vertical_gradient(i) / 100.0
+                     ug_vertical_gradient_level(i) >= 0.0_wp )  THEN
+                   gradient = ug_vertical_gradient(i) / 100.0_wp
                    ug_vertical_gradient_level_ind(i) = k - 1
                    i = i + 1
                 ENDIF
              ENDIF        
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= 1 )  THEN
                    ug(k) = ug(k-1) + dzu(k) * gradient
@@ -912,16 +912,16 @@
              IF ( i < 11 ) THEN
                 IF ( ug_vertical_gradient_level(i) > zu(k)  .AND. &
-                     ug_vertical_gradient_level(i) <= 0.0 )  THEN
-                   gradient = ug_vertical_gradient(i) / 100.0
+                     ug_vertical_gradient_level(i) <= 0.0_wp )  THEN
+                   gradient = ug_vertical_gradient(i) / 100.0_wp
                    ug_vertical_gradient_level_ind(i) = k + 1
                    i = i + 1
                 ENDIF
              ENDIF
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= nzt )  THEN
                    ug(k) = ug(k+1) - dzu(k+1) * gradient
                 ELSE
-                   ug(k)   = ug_surface - 0.5 * dzu(k+1) * gradient
-                   ug(k+1) = ug_surface + 0.5 * dzu(k+1) * gradient
+                   ug(k)   = ug_surface - 0.5_wp * dzu(k+1) * gradient
+                   ug(k+1) = ug_surface + 0.5_wp * dzu(k+1) * gradient
                 ENDIF
              ELSE
@@ -935,5 +935,5 @@
 !--    In case of no given gradients for ug, choose a zero gradient
        IF ( ug_vertical_gradient_level(1) == -9999999.9_wp )  THEN
-          ug_vertical_gradient_level(1) = 0.0
+          ug_vertical_gradient_level(1) = 0.0_wp
        ENDIF  
 
@@ -943,5 +943,5 @@
 !--    (component vg)
        i = 1
-       gradient = 0.0
+       gradient = 0.0_wp
 
        IF ( .NOT. ocean )  THEN
@@ -952,11 +952,11 @@
              IF ( i < 11 ) THEN 
                 IF ( vg_vertical_gradient_level(i) < zu(k)  .AND. &
-                     vg_vertical_gradient_level(i) >= 0.0 )  THEN
-                   gradient = vg_vertical_gradient(i) / 100.0
+                     vg_vertical_gradient_level(i) >= 0.0_wp )  THEN
+                   gradient = vg_vertical_gradient(i) / 100.0_wp
                    vg_vertical_gradient_level_ind(i) = k - 1
                    i = i + 1
                 ENDIF
              ENDIF
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= 1 )  THEN
                    vg(k) = vg(k-1) + dzu(k) * gradient
@@ -976,16 +976,16 @@
              IF ( i < 11 ) THEN
                 IF ( vg_vertical_gradient_level(i) > zu(k)  .AND. &
-                     vg_vertical_gradient_level(i) <= 0.0 )  THEN
-                   gradient = vg_vertical_gradient(i) / 100.0
+                     vg_vertical_gradient_level(i) <= 0.0_wp )  THEN
+                   gradient = vg_vertical_gradient(i) / 100.0_wp
                    vg_vertical_gradient_level_ind(i) = k + 1
                    i = i + 1
                 ENDIF
              ENDIF
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= nzt )  THEN
                    vg(k) = vg(k+1) - dzu(k+1) * gradient
                 ELSE
-                   vg(k)   = vg_surface - 0.5 * dzu(k+1) * gradient
-                   vg(k+1) = vg_surface + 0.5 * dzu(k+1) * gradient
+                   vg(k)   = vg_surface - 0.5_wp * dzu(k+1) * gradient
+                   vg(k+1) = vg_surface + 0.5_wp * dzu(k+1) * gradient
                 ENDIF
              ELSE
@@ -999,5 +999,5 @@
 !--    In case of no given gradients for vg, choose a zero gradient
        IF ( vg_vertical_gradient_level(1) == -9999999.9_wp )  THEN
-          vg_vertical_gradient_level(1) = 0.0
+          vg_vertical_gradient_level(1) = 0.0_wp
        ENDIF
 
@@ -1010,7 +1010,7 @@
           v_init = vg
 
-       ELSEIF ( u_profile(1) == 0.0  .AND.  v_profile(1) == 0.0 )  THEN
-
-          IF ( uv_heights(1) /= 0.0 )  THEN
+       ELSEIF ( u_profile(1) == 0.0_wp  .AND.  v_profile(1) == 0.0_wp )  THEN
+
+          IF ( uv_heights(1) /= 0.0_wp )  THEN
              message_string = 'uv_heights(1) must be 0.0'
              CALL message( 'check_parameters', 'PA0345', 1, 2, 0, 6, 0 )
@@ -1020,6 +1020,6 @@
 
           kk = 1
-          u_init(0) = 0.0
-          v_init(0) = 0.0
+          u_init(0) = 0.0_wp
+          v_init(0) = 0.0_wp
 
           DO  k = 1, nz+1
@@ -1058,5 +1058,5 @@
 
           i = 1
-          gradient = 0.0
+          gradient = 0.0_wp
 
           IF ( .NOT. ocean )  THEN
@@ -1066,11 +1066,11 @@
                 IF ( i < 11 ) THEN
                    IF ( pt_vertical_gradient_level(i) < zu(k)  .AND. &
-                        pt_vertical_gradient_level(i) >= 0.0 )  THEN
-                      gradient = pt_vertical_gradient(i) / 100.0
+                        pt_vertical_gradient_level(i) >= 0.0_wp )  THEN
+                      gradient = pt_vertical_gradient(i) / 100.0_wp
                       pt_vertical_gradient_level_ind(i) = k - 1
                       i = i + 1
                    ENDIF
                 ENDIF
-                IF ( gradient /= 0.0 )  THEN
+                IF ( gradient /= 0.0_wp )  THEN
                    IF ( k /= 1 )  THEN
                       pt_init(k) = pt_init(k-1) + dzu(k) * gradient
@@ -1089,16 +1089,16 @@
                 IF ( i < 11 ) THEN
                    IF ( pt_vertical_gradient_level(i) > zu(k)  .AND. &
-                        pt_vertical_gradient_level(i) <= 0.0 )  THEN
-                      gradient = pt_vertical_gradient(i) / 100.0
+                        pt_vertical_gradient_level(i) <= 0.0_wp )  THEN
+                      gradient = pt_vertical_gradient(i) / 100.0_wp
                       pt_vertical_gradient_level_ind(i) = k + 1
                       i = i + 1
                    ENDIF
                 ENDIF
-                IF ( gradient /= 0.0 )  THEN
+                IF ( gradient /= 0.0_wp )  THEN
                    IF ( k /= nzt )  THEN
                       pt_init(k) = pt_init(k+1) - dzu(k+1) * gradient
                    ELSE
-                      pt_init(k)   = pt_surface - 0.5 * dzu(k+1) * gradient
-                      pt_init(k+1) = pt_surface + 0.5 * dzu(k+1) * gradient
+                      pt_init(k)   = pt_surface - 0.5_wp * dzu(k+1) * gradient
+                      pt_init(k+1) = pt_surface + 0.5_wp * dzu(k+1) * gradient
                    ENDIF
                 ELSE
@@ -1115,5 +1115,5 @@
 !--    stratification
        IF ( pt_vertical_gradient_level(1) == -9999999.9_wp )  THEN
-          pt_vertical_gradient_level(1) = 0.0
+          pt_vertical_gradient_level(1) = 0.0_wp
        ENDIF
 
@@ -1141,16 +1141,16 @@
 
           i = 1
-          gradient = 0.0
+          gradient = 0.0_wp
           q_vertical_gradient_level_ind(1) = 0
           DO  k = 1, nzt+1
              IF ( i < 11 ) THEN
                 IF ( q_vertical_gradient_level(i) < zu(k)  .AND. &
-                     q_vertical_gradient_level(i) >= 0.0 )  THEN
-                   gradient = q_vertical_gradient(i) / 100.0
+                     q_vertical_gradient_level(i) >= 0.0_wp )  THEN
+                   gradient = q_vertical_gradient(i) / 100.0_wp
                    q_vertical_gradient_level_ind(i) = k - 1
                    i = i + 1
                 ENDIF
              ENDIF
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= 1 )  THEN
                    q_init(k) = q_init(k-1) + dzu(k) * gradient
@@ -1163,6 +1163,6 @@
 !
 !--          Avoid negative humidities
-             IF ( q_init(k) < 0.0 )  THEN
-                q_init(k) = 0.0
+             IF ( q_init(k) < 0.0_wp )  THEN
+                q_init(k) = 0.0_wp
              ENDIF
           ENDDO
@@ -1171,6 +1171,6 @@
 !--       In case of no given humidity gradients, choose zero gradient
 !--       conditions
-          IF ( q_vertical_gradient_level(1) == -1.0 )  THEN
-             q_vertical_gradient_level(1) = 0.0
+          IF ( q_vertical_gradient_level(1) == -1.0_wp )  THEN
+             q_vertical_gradient_level(1) = 0.0_wp
           ENDIF
 !
@@ -1186,5 +1186,5 @@
 
           i = 1
-          gradient = 0.0
+          gradient = 0.0_wp
 
           sa_vertical_gradient_level_ind(1) = nzt+1
@@ -1192,16 +1192,16 @@
              IF ( i < 11 ) THEN
                 IF ( sa_vertical_gradient_level(i) > zu(k)  .AND. &
-                     sa_vertical_gradient_level(i) <= 0.0 )  THEN
-                   gradient = sa_vertical_gradient(i) / 100.0
+                     sa_vertical_gradient_level(i) <= 0.0_wp )  THEN
+                   gradient = sa_vertical_gradient(i) / 100.0_wp
                    sa_vertical_gradient_level_ind(i) = k + 1
                    i = i + 1
                 ENDIF
              ENDIF
-             IF ( gradient /= 0.0 )  THEN
+             IF ( gradient /= 0.0_wp )  THEN
                 IF ( k /= nzt )  THEN
                    sa_init(k) = sa_init(k+1) - dzu(k+1) * gradient
                 ELSE
-                   sa_init(k)   = sa_surface - 0.5 * dzu(k+1) * gradient
-                   sa_init(k+1) = sa_surface + 0.5 * dzu(k+1) * gradient
+                   sa_init(k)   = sa_surface - 0.5_wp * dzu(k+1) * gradient
+                   sa_init(k+1) = sa_surface + 0.5_wp * dzu(k+1) * gradient
                 ENDIF
              ELSE
@@ -1218,5 +1218,5 @@
        
           i = 1
-          gradient = 0.0
+          gradient = 0.0_wp
 
           IF ( .NOT. ocean ) THEN
@@ -1228,5 +1228,5 @@
                 IF ( i < 11 ) THEN
                    IF ( lad_vertical_gradient_level(i) < zu(k) .AND.  &
-                        lad_vertical_gradient_level(i) >= 0.0 ) THEN
+                        lad_vertical_gradient_level(i) >= 0.0_wp ) THEN
                       gradient = lad_vertical_gradient(i)
                       lad_vertical_gradient_level_ind(i) = k - 1
@@ -1234,5 +1234,5 @@
                    ENDIF
                 ENDIF
-                IF ( gradient /= 0.0 ) THEN
+                IF ( gradient /= 0.0_wp ) THEN
                    IF ( k /= 1 ) THEN
                       lad(k) = lad(k-1) + dzu(k) * gradient
@@ -1251,5 +1251,5 @@
 !--       gradient
           IF ( lad_vertical_gradient_level(1) == -9999999.9_wp ) THEN
-             lad_vertical_gradient_level(1) = 0.0
+             lad_vertical_gradient_level(1) = 0.0_wp
           ENDIF
 
@@ -1287,6 +1287,6 @@
 !
 !-- Compute Coriolis parameter
-    f  = 2.0 * omega * SIN( phi / 180.0 * pi )
-    fs = 2.0 * omega * COS( phi / 180.0 * pi )
+    f  = 2.0_wp * omega * SIN( phi / 180.0_wp * pi )
+    fs = 2.0_wp * omega * COS( phi / 180.0_wp * pi )
 
 !
@@ -1299,5 +1299,5 @@
        use_single_reference_value = .TRUE.
        IF ( pt_reference == 9999999.9_wp )  pt_reference = pt_surface
-       vpt_reference = pt_reference * ( 1.0 + 0.61 * q_surface )
+       vpt_reference = pt_reference * ( 1.0_wp + 0.61_wp * q_surface )
     ELSE
        message_string = 'illegal value for reference_state: "' // &
@@ -1315,5 +1315,5 @@
 !
 !-- Sign of buoyancy/stability terms
-    IF ( ocean )  atmos_ocean_sign = -1.0
+    IF ( ocean )  atmos_ocean_sign = -1.0_wp
 
 !
@@ -1326,6 +1326,6 @@
 !
 !-- In case of a given slope, compute the relevant quantities
-    IF ( alpha_surface /= 0.0 )  THEN
-       IF ( ABS( alpha_surface ) > 90.0 )  THEN
+    IF ( alpha_surface /= 0.0_wp )  THEN
+       IF ( ABS( alpha_surface ) > 90.0_wp )  THEN
           WRITE( message_string, * ) 'ABS( alpha_surface = ', alpha_surface, &
                                      ' ) must be < 90.0'
@@ -1333,12 +1333,12 @@
        ENDIF
        sloping_surface = .TRUE.
-       cos_alpha_surface = COS( alpha_surface / 180.0 * pi )
-       sin_alpha_surface = SIN( alpha_surface / 180.0 * pi )
+       cos_alpha_surface = COS( alpha_surface / 180.0_wp * pi )
+       sin_alpha_surface = SIN( alpha_surface / 180.0_wp * pi )
     ENDIF
 
 !
 !-- Check time step and cfl_factor
-    IF ( dt /= -1.0 )  THEN
-       IF ( dt <= 0.0  .AND.  dt /= -1.0 )  THEN
+    IF ( dt /= -1.0_wp )  THEN
+       IF ( dt <= 0.0_wp  .AND.  dt /= -1.0_wp )  THEN
           WRITE( message_string, * ) 'dt = ', dt , ' <= 0.0'
           CALL message( 'check_parameters', 'PA0044', 1, 2, 0, 6, 0 )
@@ -1348,12 +1348,12 @@
     ENDIF
 
-    IF ( cfl_factor <= 0.0  .OR.  cfl_factor > 1.0 )  THEN
-       IF ( cfl_factor == -1.0 )  THEN
+    IF ( cfl_factor <= 0.0_wp  .OR.  cfl_factor > 1.0_wp )  THEN
+       IF ( cfl_factor == -1.0_wp )  THEN
           IF ( timestep_scheme == 'runge-kutta-2' )  THEN
-             cfl_factor = 0.8
+             cfl_factor = 0.8_wp
           ELSEIF ( timestep_scheme == 'runge-kutta-3' )  THEN
-             cfl_factor = 0.9
+             cfl_factor = 0.9_wp
           ELSE
-             cfl_factor = 0.9
+             cfl_factor = 0.9_wp
           ENDIF
        ELSE
@@ -1371,8 +1371,8 @@
 !-- Store reference time for coupled runs and change the coupling flag,
 !-- if ...
-    IF ( simulated_time == 0.0 )  THEN
-       IF ( coupling_start_time == 0.0 )  THEN
-          time_since_reference_point = 0.0
-       ELSEIF ( time_since_reference_point < 0.0 )  THEN
+    IF ( simulated_time == 0.0_wp )  THEN
+       IF ( coupling_start_time == 0.0_wp )  THEN
+          time_since_reference_point = 0.0_wp
+       ELSEIF ( time_since_reference_point < 0.0_wp )  THEN
           run_coupled = .FALSE.
        ENDIF
@@ -1382,20 +1382,20 @@
 !-- Set wind speed in the Galilei-transformed system
     IF ( galilei_transformation )  THEN
-       IF ( use_ug_for_galilei_tr .AND.                  &
-            ug_vertical_gradient_level(1) == 0.0  .AND.  &
-            ug_vertical_gradient(1) == 0.0  .AND.        & 
-            vg_vertical_gradient_level(1) == 0.0  .AND.  &
-            vg_vertical_gradient(1) == 0.0 )  THEN
-          u_gtrans = ug_surface * 0.6
-          v_gtrans = vg_surface * 0.6
-       ELSEIF ( use_ug_for_galilei_tr  .AND.                  &
-                ( ug_vertical_gradient_level(1) /= 0.0  .OR.  &
-                ug_vertical_gradient(1) /= 0.0 ) )  THEN
+       IF ( use_ug_for_galilei_tr .AND.                     &
+            ug_vertical_gradient_level(1) == 0.0_wp  .AND.  &
+            ug_vertical_gradient(1) == 0.0_wp  .AND.        & 
+            vg_vertical_gradient_level(1) == 0.0_wp  .AND.  &
+            vg_vertical_gradient(1) == 0.0_wp )  THEN
+          u_gtrans = ug_surface * 0.6_wp
+          v_gtrans = vg_surface * 0.6_wp
+       ELSEIF ( use_ug_for_galilei_tr  .AND.                     &
+                ( ug_vertical_gradient_level(1) /= 0.0_wp  .OR.  &
+                ug_vertical_gradient(1) /= 0.0_wp ) )  THEN
           message_string = 'baroclinity (ug) not allowed simultaneously' // &
                            ' with galilei transformation'
           CALL message( 'check_parameters', 'PA0046', 1, 2, 0, 6, 0 )
-       ELSEIF ( use_ug_for_galilei_tr  .AND.                  &
-                ( vg_vertical_gradient_level(1) /= 0.0  .OR.  &
-                vg_vertical_gradient(1) /= 0.0 ) )  THEN
+       ELSEIF ( use_ug_for_galilei_tr  .AND.                     &
+                ( vg_vertical_gradient_level(1) /= 0.0_wp  .OR.  &
+                vg_vertical_gradient(1) /= 0.0_wp ) )  THEN
           message_string = 'baroclinity (vg) not allowed simultaneously' // &
                            ' with galilei transformation'
@@ -1561,5 +1561,5 @@
     IF ( neutral )  THEN
 
-       IF ( surface_heatflux /= 0.0  .AND.  surface_heatflux /= 9999999.9_wp ) &
+       IF ( surface_heatflux /= 0.0_wp  .AND.  surface_heatflux /= 9999999.9_wp ) &
        THEN
           message_string = 'heatflux must not be set for pure neutral flow'
@@ -1590,10 +1590,10 @@
 !-- forbidden.
     IF ( ibc_pt_b == 0  .AND.   constant_heatflux  .AND. &
-         surface_heatflux /= 0.0 )  THEN
+         surface_heatflux /= 0.0_wp )  THEN
        message_string = 'boundary_condition: bc_pt_b = "' // TRIM( bc_pt_b ) //&
                         '& is not allowed with constant_heatflux = .TRUE.'
        CALL message( 'check_parameters', 'PA0065', 1, 2, 0, 6, 0 )
     ENDIF
-    IF ( constant_heatflux  .AND.  pt_surface_initial_change /= 0.0 )  THEN
+    IF ( constant_heatflux  .AND.  pt_surface_initial_change /= 0.0_wp )  THEN
        WRITE ( message_string, * )  'constant_heatflux = .TRUE. is not allo', &
                'wed with pt_surface_initial_change (/=0) = ', &
@@ -1607,5 +1607,5 @@
 !-- forbidden.
     IF ( ibc_pt_t == 0  .AND.   constant_top_heatflux  .AND. &
-         top_heatflux /= 0.0 )  THEN
+         top_heatflux /= 0.0_wp )  THEN
        message_string = 'boundary_condition: bc_pt_t = "' // TRIM( bc_pt_t ) //&
                         '" is not allowed with constant_top_heatflux = .TRUE.'
@@ -1639,5 +1639,5 @@
 !--    forbidden.
        IF ( ibc_sa_t == 0  .AND.   constant_top_salinityflux  .AND. &
-            top_salinityflux /= 0.0 )  THEN
+            top_salinityflux /= 0.0_wp )  THEN
           message_string = 'boundary condition: bc_sa_t = "' // &
                            TRIM( bc_sa_t ) // '" is not allowed with ' // &
@@ -1706,5 +1706,5 @@
           CALL message( 'check_parameters', 'PA0073', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( constant_waterflux  .AND.  q_surface_initial_change /= 0.0 )  THEN
+       IF ( constant_waterflux  .AND.  q_surface_initial_change /= 0.0_wp )  THEN
           WRITE( message_string, * )  'a prescribed surface flux is not allo', &
                  'wed with ', sq, '_surface_initial_change (/=0) = ', &
@@ -1747,6 +1747,6 @@
 !--          Velocities for the initial u,v-profiles are set zero at the top
 !--          in case of dirichlet_0 conditions
-             u_init(nzt+1)    = 0.0
-             v_init(nzt+1)    = 0.0
+             u_init(nzt+1)    = 0.0_wp
+             v_init(nzt+1)    = 0.0_wp
           ENDIF
        ELSEIF ( bc_uv_t == 'neumann' )  THEN
@@ -1761,8 +1761,8 @@
 !
 !-- Compute and check, respectively, the Rayleigh Damping parameter
-    IF ( rayleigh_damping_factor == -1.0 )  THEN
-       rayleigh_damping_factor = 0.0
+    IF ( rayleigh_damping_factor == -1.0_wp )  THEN
+       rayleigh_damping_factor = 0.0_wp
     ELSE
-       IF ( rayleigh_damping_factor < 0.0 .OR. rayleigh_damping_factor > 1.0 ) &
+       IF ( rayleigh_damping_factor < 0.0 .OR. rayleigh_damping_factor > 1.0_wp ) &
        THEN
           WRITE( message_string, * )  'rayleigh_damping_factor = ', &
@@ -1772,13 +1772,13 @@
     ENDIF
 
-    IF ( rayleigh_damping_height == -1.0 )  THEN
+    IF ( rayleigh_damping_height == -1.0_wp )  THEN
        IF ( .NOT. ocean )  THEN
-          rayleigh_damping_height = 0.66666666666 * zu(nzt)
+          rayleigh_damping_height = 0.66666666666_wp * zu(nzt)
        ELSE
-          rayleigh_damping_height = 0.66666666666 * zu(nzb)
+          rayleigh_damping_height = 0.66666666666_wp * zu(nzb)
        ENDIF
     ELSE
        IF ( .NOT. ocean )  THEN
-          IF ( rayleigh_damping_height < 0.0  .OR. &
+          IF ( rayleigh_damping_height < 0.0_wp  .OR. &
                rayleigh_damping_height > zu(nzt) )  THEN
              WRITE( message_string, * )  'rayleigh_damping_height = ', &
@@ -1787,5 +1787,5 @@
           ENDIF
        ELSE
-          IF ( rayleigh_damping_height > 0.0  .OR. &
+          IF ( rayleigh_damping_height > 0.0_wp  .OR. &
                rayleigh_damping_height < zu(nzb) )  THEN
              WRITE( message_string, * )  'rayleigh_damping_height = ', &
@@ -1816,6 +1816,6 @@
 !-- Check the interval for sorting particles.
 !-- Using particles as cloud droplets requires sorting after each timestep.
-    IF ( dt_sort_particles /= 0.0  .AND.  cloud_droplets )  THEN
-       dt_sort_particles = 0.0
+    IF ( dt_sort_particles /= 0.0_wp  .AND.  cloud_droplets )  THEN
+       dt_sort_particles = 0.0_wp
        message_string = 'dt_sort_particles is reset to 0.0 because of cloud' //&
                         '_droplets = .TRUE.'
@@ -1899,5 +1899,5 @@
 !-- value (tries to minimize the number of calls of flow_statistics)
     IF ( dt_dots == 9999999.9_wp )  THEN
-       IF ( averaging_interval_pr == 0.0 )  THEN
+       IF ( averaging_interval_pr == 0.0_wp )  THEN
           dt_dots = MIN( dt_run_control, dt_dopr )
        ELSE
@@ -1983,5 +1983,5 @@
                    dopr_initial_index(i) = 7
                    hom(:,2,7,:)          = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,7,:)        = 0.0    ! because zu(nzb) is negative
+                   hom(nzb,2,7,:)        = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -1993,5 +1993,5 @@
                    dopr_initial_index(i) = 28
                    hom(:,2,28,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,28,:)       = 0.0    ! because zu(nzb) is negative
+                   hom(nzb,2,28,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2002,5 +2002,5 @@
              dopr_unit(i)   = 'm2/s2'
              hom(:,2,8,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,8,:) = 0.0
+             hom(nzb,2,8,:) = 0.0_wp
 
           CASE ( 'km', '#km' )
@@ -2008,5 +2008,5 @@
              dopr_unit(i)   = 'm2/s'
              hom(:,2,9,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,9,:) = 0.0
+             hom(nzb,2,9,:) = 0.0_wp
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 23
@@ -2019,5 +2019,5 @@
              dopr_unit(i)    = 'm2/s'
              hom(:,2,10,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,10,:) = 0.0
+             hom(nzb,2,10,:) = 0.0_wp
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 24
@@ -2030,5 +2030,5 @@
              dopr_unit(i)    = 'm'
              hom(:,2,11,:)   = SPREAD( zu, 2, statistic_regions+1 )
-             hom(nzb,2,11,:) = 0.0
+             hom(nzb,2,11,:) = 0.0_wp
              IF ( data_output_pr(i)(1:1) == '#' )  THEN
                 dopr_initial_index(i) = 25
@@ -2109,5 +2109,5 @@
                    dopr_initial_index(i) = 26
                    hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2182,5 +2182,5 @@
                    dopr_initial_index(i) = 26
                    hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2200,5 +2200,5 @@
                    dopr_initial_index(i) = 26
                    hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2213,5 +2213,5 @@
                    dopr_initial_index(i) = 26
                    hom(:,2,26,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,26,:)       = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,26,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2223,5 +2223,5 @@
                    dopr_initial_index(i) = 27
                    hom(:,2,27,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,27,:)       = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,27,:)       = 0.0_wp   ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2241,5 +2241,5 @@
                    dopr_initial_index(i) = 7
                    hom(:,2,7,:)          = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,7,:)        = 0.0    ! weil zu(nzb) negativ ist
+                   hom(nzb,2,7,:)        = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2253,5 +2253,5 @@
                 dopr_initial_index(i) = 29
                 hom(:,2,29,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                hom(nzb,2,29,:)       = 0.0    ! weil zu(nzb) negativ ist
+                hom(nzb,2,29,:)       = 0.0_wp    ! because zu(nzb) is negative
                 data_output_pr(i)     = data_output_pr(i)(2:)
              ENDIF
@@ -2470,5 +2470,5 @@
                    dopr_initial_index(i) = 77
                    hom(:,2,77,:)         = SPREAD( zu, 2, statistic_regions+1 )
-                   hom(nzb,2,77,:)       = 0.0    ! because zu(nzb) is negative
+                   hom(nzb,2,77,:)       = 0.0_wp    ! because zu(nzb) is negative
                    data_output_pr(i)     = data_output_pr(i)(2:)
                 ENDIF
@@ -2977,5 +2977,5 @@
 !
 !-- Averaged 2d or 3d output requires that an averaging interval has been set
-    IF ( doav_n > 0  .AND.  averaging_interval == 0.0 )  THEN
+    IF ( doav_n > 0  .AND.  averaging_interval == 0.0_wp )  THEN
        WRITE( message_string, * )  'output of averaged quantity "',            &
                                    TRIM( doav(1) ), '_av" requires to set a ', &
@@ -3004,5 +3004,5 @@
 !
 !-- Upper plot limit for 2D vertical sections
-    IF ( z_max_do2d == -1.0 )  z_max_do2d = zu(nzt)
+    IF ( z_max_do2d == -1.0_wp )  z_max_do2d = zu(nzt)
     IF ( z_max_do2d < zu(nzb+1)  .OR.  z_max_do2d > zu(nzt) )  THEN
        WRITE( message_string, * )  'z_max_do2d = ', z_max_do2d, &
@@ -3066,5 +3066,5 @@
        mask_scale(2) = mask_scale_y
        mask_scale(3) = mask_scale_z
-       IF ( ANY( mask_scale <= 0.0 ) )  THEN
+       IF ( ANY( mask_scale <= 0.0_wp ) )  THEN
           WRITE( message_string, * )  &
                'illegal value: mask_scale_x, mask_scale_y and mask_scale_z', &
@@ -3151,10 +3151,10 @@
 !
 !-- Check, whether a constant diffusion coefficient shall be used
-    IF ( km_constant /= -1.0 )  THEN
-       IF ( km_constant < 0.0 )  THEN
+    IF ( km_constant /= -1.0_wp )  THEN
+       IF ( km_constant < 0.0_wp )  THEN
           WRITE( message_string, * )  'km_constant = ', km_constant, ' < 0.0'
           CALL message( 'check_parameters', 'PA0121', 1, 2, 0, 6, 0 )
        ELSE
-          IF ( prandtl_number < 0.0 )  THEN
+          IF ( prandtl_number < 0.0_wp )  THEN
              WRITE( message_string, * )  'prandtl_number = ', prandtl_number, &
                                          ' < 0.0'
